//
//  AudioRecorder.m
//  WBA
//
//  Created by Class Account on 4/25/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "AudioNote.h"
#import "Board.h"

@implementation AudioNote

@synthesize soundPath;

- (void)didReceiveMemoryWarning {
  // Releases the view if it doesn't have a superview.
  [super didReceiveMemoryWarning];
	
  // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
  // Release any retained subviews of the main view.
  // e.g. self.myOutlet = nil;
}

- (void) setModel: (Board*) b {
  model = b;
}



- (void)dealloc {
  [super dealloc];
  [soundFileURL release];
  [soundPath release];
}

- (void) beginRecording {
  // Home directory as dirname
   NSString *homeDir = NSHomeDirectory();
		//NSString *docDir = NSTemporaryDirectory();
  
  // Create a filename
  NSDate *today = [NSDate date];
  NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
  [dateFormatter setDateFormat:@"yyy-MM-dd-hh:mm:ss"];
  NSString *currentFile = [dateFormatter stringFromDate:today];
  [dateFormatter release];

  // Append dirname and filename
  soundPath = [[NSString alloc] initWithFormat:@"%@/Documents/%@.caf", homeDir, currentFile];


  // Turn path string into NSURL
  NSURL *newURL = [[NSURL alloc] initFileURLWithPath: soundPath];
  soundFileURL = newURL;
  [soundFileURL retain];
  NSLog(@"The url is ");
  NSLog([soundFileURL path]);

  

  AVAudioSession *audioSession = [AVAudioSession sharedInstance];
  audioSession.delegate = nil;
  NSError *setCategoryError = nil;

  [audioSession setActive: YES error: &setCategoryError];	
		
  
  [[AVAudioSession sharedInstance]
    setCategory: AVAudioSessionCategoryRecord
    error: nil];
  
	NSDictionary *recordSettings=[[NSDictionary alloc] initWithObjectsAndKeys:
									[NSNumber numberWithInt:kAudioFormatAppleIMA4],AVFormatIDKey,
									   [NSNumber numberWithInt:44100.0],AVSampleRateKey,
									   [NSNumber numberWithInt: 2],AVNumberOfChannelsKey,
									   [NSNumber numberWithInt:16],AVLinearPCMBitDepthKey,
									   [NSNumber numberWithBool:NO],AVLinearPCMIsBigEndianKey,
									   [NSNumber numberWithBool:NO],AVLinearPCMIsFloatKey,
									   nil];
  
  soundRecorder = [[AVAudioRecorder alloc] initWithURL: soundFileURL
					   settings: recordSettings
					   error: nil];
  [recordSettings release];
  [soundRecorder retain];
  // No delegate is actually necessary..
  [soundRecorder setDelegate:nil];
  [soundRecorder prepareToRecord];
  [soundRecorder record];
  
}

- (void) stopRecording {
  [soundRecorder stop];
  [soundRecorder release];
  soundRecorder = nil;
	
	[[AVAudioSession sharedInstance] setActive: NO error: nil];
	[[AVAudioSession sharedInstance]
	 setCategory: AVAudioSessionCategoryPlayback
	 error: nil];
}


- (void) timerThread {
  while (isRecording) {
    [NSThread sleepForTimeInterval:1.0];
    if (recordingAlert != nil) {
      seconds++;
      [self performSelectorOnMainThread : @ selector(updateRecordTimer) withObject:nil waitUntilDone:YES];
    }
  }
}

- (void) updateRecordTimer {
  NSString *newMsg = [[NSString alloc] initWithFormat:@"                       %d:%02d",
				       seconds / 60, 
				       seconds % 60];
  NSString *oldText = recTimer.text;
  recTimer.text = newMsg;
  [oldText release];
}

- (void) record {
  NSLog(@"Recording now, inside AudioNote\n");
  isRecording = YES;

  NSLog(@"done starting recorder\n");
  seconds = 0;
  // Spawn recording timer update thread
  [NSThread detachNewThreadSelector:@selector(timerThread) toTarget:self withObject:nil];
  recordingAlert = [[[UIAlertView alloc] initWithTitle:@"You are now recording..."
					 message:@"  " // Just some spacing, it's for the recTimer
					 delegate: self
					 cancelButtonTitle:nil otherButtonTitles:@"Done", nil] autorelease];
  // RecTimer can be an arbitrary view. Eg a view with a blinking RECORD image with accompanying text
  recTimer = [[UILabel alloc] initWithFrame:CGRectMake(12.0, 45.0, 260.0, 25.0)];
  [recTimer setText:@"                       0:00"];
  [recTimer setBackgroundColor:[UIColor clearColor]];
  [recTimer setTextColor:[UIColor whiteColor]];
  [recordingAlert addSubview:recTimer];
  [recordingAlert show];

	[self beginRecording];
}

- (void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex {
  if (buttonIndex == 0) {
    isRecording = NO;
    [self stopRecording];
  } 

}

@end
