//
//  Board.h
//  WBA
//
//  Created by Class Account on 3/29/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BoardSection.h"


@interface Board : NSObject {
	NSArray *sections;

	LayoutType layout;
	int minutes;
	int physicalBoardNumber;
}

@property (nonatomic, retain) NSArray *sections;
@property (readwrite, assign) LayoutType layout;
@property (readwrite, assign) int minutes;
@property (readwrite, assign) int physicalBoardNumber;

-(id)initWithLayoutType:(LayoutType)layType;
-(id)initAsCopy:(Board*)other;
-(void)changeLayout:(LayoutType)layType;
-(BOOL)isBlank;

-(NSArray*)setupRegions:(LayoutType)layType;

-(BoardSection*)sectionContainingPoint:(CGPoint)point;
-(bool)pointOnPhotoButton:(CGPoint)point atSection:(BoardSection *) section  region:(CGRect) drawRegion thumbSize:(int) thumbSize;
-(bool)pointOnFlagButton:(CGPoint)point atSection:(BoardSection *) section   region:(CGRect) drawRegion;
-(NSMutableDictionary *)serialize;

@end
