//
//  BoardSection.h
//  WBA
//
//  Created by Class Account on 3/29/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "globals.h"
#import "WBAAppDelegate.h"



@interface BoardSection : NSObject {
  CGRect region;
  ElementType type;
  UIImage *photoAnnotation;
  NSString *textAnnotation;
  bool hasPhoto;
  bool hasText;

  NSString *soundFile;
	NSString *photoFile;

	// Something pointing to a photo goes here...

}

@property (readwrite, assign) CGRect region;
@property (readwrite, assign) ElementType type;
@property (readonly, copy) NSString *textAnnotation;
@property (readwrite, assign) bool hasText;
@property (readwrite, assign) bool hasPhoto;
@property (readwrite, assign) NSString *soundFile;
//@property (readwrite, assign) NSString *photoFile;


// Does NOT copy region
-(void)copyFrom:(BoardSection*)other;

-(bool)containsPoint:(CGPoint)point;
-(bool)pointOnPhotoButton:(CGPoint)point  literalSize:(CGPoint)size;
-(bool)pointOnFlagButton:(CGPoint)point  literalSize:(CGPoint)size;
-(NSMutableDictionary *)serialize;

-(float)getOriginX;
-(float)getOriginY;
-(float)getWidth;
-(float)getHeight;

-(void)clearContents;
-(void)setPhotoAnnotation:(UIImage*) image;
-(void)setTextAnnotation:(NSString*) s;
-(UIImage*) getPhotoAnnotation;
-(NSString*)getTextAnnotation;
-(void)removeTextAnnotation;
-(void)removePhotoAnnotation;
-(void)setPhotoFilePath:(NSString*) path;
-(NSString*)getPhotoFilePath;
-(bool)hasPhoto;
-(bool)hasText;
-(bool)hasFlag;
@end
