//
//  BoardView.h
//  WBA
//
//  Created by Class Account on 4/2/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Board.h"

// Superclass for all board views
@interface BoardView : UIView {
	CGRect drawRegion;
	int separatorWidth;
	int flagSize;
	int thumbSize;
	Board *model;
	NSMutableArray *myLabels;
	UIViewController *controller;
}

@property (nonatomic, retain) Board *model;

-(void)commonConstructor;

-(void)drawBoard;
-(void)drawSectionOutlines;
-(void)drawBoardHelpNotice;
-(void)drawSection:(BoardSection*)section;
-(void)drawSectionText:(BoardSection*)section labelsOnly:(BOOL)lablesOnly;
-(void)drawSectionPhotoIcon:(BoardSection*)section;

-(BoardSection*)sectionContainingPoint:(CGPoint)point;
-(bool)pointOnPhotoButton:(CGPoint)point;

-(void)setModel:(Board*)mod;
-(void)setViewController:(UIViewController*)vc;

@end
