//
//  BoardViewController.h
//  WBA
//
//  Created by Class Account on 3/18/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Board.h"
#import "Lecture.h"
#import "EditorBoardView.h"
#import "ElementButton.h"
#import "BoardViewOverlay.h"

@interface BoardViewController : UIViewController <UIActionSheetDelegate, UINavigationControllerDelegate, UIImagePickerControllerDelegate, UIScrollViewDelegate> {
	UIView *myView;

	// Model;
	Lecture *lecture;
	int positionInLecture;	// Is now changed by the scrolling of the scroll view
	
	// Logic
	bool hasSelectedButton;
	ElementButton *selectedButton;
	UIImage *revertImage;
	
	// Boards view(s)
	UIScrollView *scrollBoardsView;
	NSMutableArray *boardViews;
	
	// Scroll view UI elements
	UIScrollView *scrollElementsView;
	ElementButton *proofButton;
	ElementButton *theoremButton;
	ElementButton *definitionButton;
	ElementButton *graphButton;
	ElementButton *diagramButton;
	ElementButton *uoListButton;
	ElementButton *oListButton;
	ElementButton *exampleButton;
	ElementButton *qaButton;
	ElementButton *customButton;
	
	// Other UI elements
	UIToolbar *myToolbar;
	UIBarButtonItem *changeLayout;
	UIBarButtonItem *accept;
	UIBarButtonItem *add;
	UIBarButtonItem *timing;
	UIBarButtonItem *boardPos;

	// UIActionSheets
	UIActionSheet *rootPopUp;
	UIActionSheet *photoPopUp;
	UIActionSheet *textPopUp;
	
	// etc.
	BoardSection *annotatee;
	UIAlertView  *annotate_alert;
	UITextField  *annotate_textfield;
	UITextField *physBoardNum;
	
	BoardViewOverlay *overlay;
	
}

@property (nonatomic, retain) Lecture *lecture;
@property (readwrite, assign) int positionInLecture;
@property (nonatomic, retain) IBOutlet UIScrollView *scrollElementsView;
@property (nonatomic, retain) IBOutlet UIScrollView *scrollBoardsView;
@property (nonatomic, retain) BoardViewOverlay *overlay;
@property (nonatomic, retain) IBOutlet UIView *myView;
@property (nonatomic, retain) IBOutlet UIToolbar *myToolbar;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *changeLayout;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *accept;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *add;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *boardPos;

-(IBAction)toolbarButtonPressed:(id)sender;

-(void)elementSelected:(id)sender;
-(void)deselectElement;

-(void)setupBoardViews;
-(void)refreshBoardViews;
-(void)addBoardToBoardViews:(int)pos;

-(ElementButton*)setupElementButton:(NSString*)name atPosition:(int)pos;

-(EditorBoardView*)getBoardView;
-(UIViewController*)getLectureOverviewController;
-(void)popToLectureOverview;

-(void)setAnnotation:(BoardSection*) bsect;
-(void)setTextAnnotation;
-(void)setPhotoAnnotation:(BOOL) newPhoto;
-(void)removeTextAnnotation;
-(void)removePhotoAnnotation;
-(void)removeElement;

-(void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex;

-(void)markAsNewBoard;

		   
@end
