//
//  ChooseLayoutViewController.m
//  WBA
//
//  Created by Class Account on 3/18/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ChooseLayoutViewController.h"
#import "BoardViewController.h"


@implementation ChooseLayoutViewController

@synthesize scrollLayoutView;
@synthesize makeNewBoardEditor;
@synthesize model;
@synthesize positionInLecture;
@synthesize existingBoard;
@synthesize boardEditor;

 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
		makeNewBoardEditor = NO;
    }
    return self;
}

-(UIButton*)makeLayoutButton:(NSString*)iconName hPos:(int)hpos vPos:(int)vpos
{
	float hPosition = 10 + hpos*(LAYOUT_ICON_WIDTH+LAYOUT_ICON_HSPACE);
	float vPosition = 10 + vpos*(LAYOUT_ICON_HEIGHT+LAYOUT_ICON_VSPACE);
	
	UIButton *btn = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	btn.frame = CGRectMake(hPosition, vPosition, LAYOUT_ICON_WIDTH, LAYOUT_ICON_HEIGHT);
	btn.bounds = CGRectMake(0, 0, LAYOUT_ICON_WIDTH, LAYOUT_ICON_HEIGHT);
	[btn setBackgroundImage:[UIImage imageNamed:iconName] forState:UIControlStateNormal];
	[btn addTarget:self action:@selector(chooseLayout:) forControlEvents:UIControlEventTouchUpInside];
	
	return btn;
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	self.navigationItem.title = @"Choose This Board's Layout";
	self.navigationController.navigationBarHidden = NO;
	// self.navigationItem.hidesBackButton = YES;
	
	layoutsView = [[UIView alloc] initWithFrame:CGRectMake(0,5,810,200)];
	layoutsView.contentMode = UIViewContentModeScaleAspectFit;
	[scrollLayoutView setContentSize:CGSizeMake(layoutsView.frame.size.width, layoutsView.frame.size.height)];
	
	fullBoard_btn = [[self makeLayoutButton:@"FullBoard_Icon.png" hPos:0 vPos:0] retain];
	vert2Split_btn = [[self makeLayoutButton:@"Vert2Split_Icon.png" hPos:1 vPos:0] retain];
	horiz2Split_btn = [[self makeLayoutButton:@"Horiz2Split_Icon.png" hPos:2 vPos:0] retain];
	
	vert2and1Split_btn = [[self makeLayoutButton:@"Vert2and1Split_Icon.png" hPos:0 vPos:1] retain];
	vert3Split_btn = [[self makeLayoutButton:@"Vert3Split_Icon.png" hPos:1 vPos:1] retain];
	vert1and2Split_btn = [[self makeLayoutButton:@"Vert1and2Split_Icon.png" hPos:2 vPos:1] retain];
	
	horiz2and1Split_btn = [[self makeLayoutButton:@"Horiz2and1Split_Icon.png" hPos:3 vPos:0] retain];
	horiz1and2Split_btn = [[self makeLayoutButton:@"Horiz1and2Split_Icon.png" hPos:4 vPos:0] retain];
	horiz3Split_btn = [[self makeLayoutButton:@"Horiz3Split_Icon.png" hPos:3 vPos:1] retain];
	fourWaySplit_btn = [[self makeLayoutButton:@"FourWaySplit_Icon.png" hPos:4 vPos:1] retain];
		
	[scrollLayoutView addSubview:layoutsView];
	[layoutsView addSubview:fullBoard_btn];
	[layoutsView addSubview:vert2Split_btn];
	[layoutsView addSubview:horiz2Split_btn];
	[layoutsView addSubview:vert2and1Split_btn];
	[layoutsView addSubview:vert3Split_btn];
	[layoutsView addSubview:vert1and2Split_btn];
	[layoutsView addSubview:horiz2and1Split_btn];
	[layoutsView addSubview:horiz1and2Split_btn];
	[layoutsView addSubview:horiz3Split_btn];
	[layoutsView addSubview:fourWaySplit_btn];
	
}

-(void)viewDidAppear:(BOOL)animated
{
	[super viewDidAppear:animated];
	[scrollLayoutView flashScrollIndicators];
}

-(IBAction)chooseLayout:(id)sender
{
	LayoutType ltype;
	if (sender == fullBoard_btn)
		ltype = FullBoard;
	if (sender == vert2Split_btn)
		ltype = Vert2Split;
	if (sender == horiz2Split_btn)
		ltype = Horiz2Split;
	if (sender == vert2and1Split_btn)
		ltype = Vert2and1Split;
	if (sender == vert3Split_btn)
		ltype = Vert3Split;
	if (sender == vert1and2Split_btn)
		ltype = Vert1and2Split;
	if (sender == horiz2and1Split_btn)
		ltype = Horiz2and1Split;
	if (sender == horiz1and2Split_btn)
		ltype = Horiz1and2Split;
	if (sender == horiz3Split_btn)
		ltype = Horiz3Split;
	if (sender == fourWaySplit_btn)
		ltype = FourWaySplit;
	// etc.
	
	// If we're editing an existing board, then just change layout and pop
	// back to existing board editor
	if (existingBoard)
	{
		[existingBoard changeLayout:ltype];
		[self.navigationController popViewControllerAnimated:NO];
	}
	// If we got here from the "Add board" button, add a new board and then
	// pop back to existing board editor
	else if (!makeNewBoardEditor)
	{
		Board *newBoard = [[Board alloc] initWithLayoutType:ltype];
		[model addBoard:newBoard atPosition:positionInLecture];
		((BoardViewController*)boardEditor).positionInLecture = positionInLecture;
		[(BoardViewController*)boardEditor addBoardToBoardViews:positionInLecture];
		[self.navigationController popViewControllerAnimated:NO];
	}
	// Otherwise, we need to make a new board AND a new board editor
	else
	{
		Board *newBoard = [[Board alloc] initWithLayoutType:ltype];
		BoardViewController *bVC = [[BoardViewController alloc] initWithNibName:@"BoardViewController" bundle:nil];
		[model addBoard:newBoard atPosition:positionInLecture];
		bVC.lecture = model;
		bVC.positionInLecture = positionInLecture;
		[self.navigationController pushViewController:bVC animated:NO];
		[newBoard release];
		[bVC release];
	}
}


// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
	if (interfaceOrientation == UIInterfaceOrientationLandscapeLeft || interfaceOrientation == UIInterfaceOrientationLandscapeRight){
		return YES;
	}else
	{
		//Doing it this way because we may want some screens to support portrait later, like the lecture chooser.
		return NO;
	}
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	if (model)
		[model release];
	if (existingBoard)
		[existingBoard release];
	[fullBoard_btn release];
	[horiz2Split_btn release];
	[vert2Split_btn release];
	[vert2and1Split_btn release];
	[vert1and2Split_btn release];
	[vert3Split_btn release];
	[horiz2and1Split_btn release];
	[horiz1and2Split_btn release];
	[horiz3Split_btn release];
	[fourWaySplit_btn release];
	[boardEditor release];
    [super dealloc];
}


@end
