//
//  ClassroomConfigViewController.m
//  WBA
//
//  Created by Class Account on 4/22/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ClassroomConfigViewController.h"
//#import "ClassroomConfigLoadViewController.h"


@implementation ClassroomConfigViewController

@synthesize doneButton, addButton, removeButton, lecture, buttonsView, saveButton, loadButton;

 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
		boardButtons = [[NSMutableArray alloc] init];
    }
    return self;
}

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}

-(void)viewWillAppear:(BOOL)animated
{
	[super viewWillAppear:animated];
	
	// Set up boards according to lecture data structure
	for (int i = 0; i < lecture.physBoardPos.count; i++)
	{
		// Add a button, then change it's location appropriately
		[self toolbarButtonPressed:addButton];
		UIButton *bb = [boardButtons objectAtIndex:i];
		CGPoint origin = [(NSValue*)[lecture.physBoardPos objectAtIndex:i] CGPointValue];
		bb.frame = CGRectMake(origin.x, origin.y, bb.frame.size.width, bb.frame.size.height);
	}
}

-(void)selectBoardButton:(UIButton*)bb
{
	[bb setBackgroundImage:[UIImage imageNamed:@"FullBoard_Highlighted.png"] forState:UIControlStateNormal];
	bb.alpha = 0.5;
	selectedButton = bb;
	
	// Deselect other boards (if any)
	for (id obj in boardButtons)
		if (obj != bb)
		{
			((UIButton*)obj).alpha = 1.0;
			[(UIButton*)obj setBackgroundImage:[UIImage imageNamed:@"FullBoard_Icon.png"] forState:UIControlStateNormal];
		}
}

-(void)deselectBoardButton
{
	[selectedButton setBackgroundImage:[UIImage imageNamed:@"FullBoard_Icon.png"] forState:UIControlStateNormal];
	selectedButton.alpha = 1.0;
	selectedButton = nil;
}

-(IBAction)toolbarButtonPressed:(id)sender
{
	if (sender == doneButton)
	{
		// Set the lecture model accordingly
		[lecture.physBoardPos removeAllObjects];
		for (id obj in boardButtons)
		{
			UIButton *bb = obj;
			[lecture.physBoardPos addObject:[NSValue valueWithCGPoint:bb.frame.origin]];
		}
		
		// Go back to settings
		[self dismissModalViewControllerAnimated:YES];
	}
	if (sender == addButton)
	{
		// Add a board
		UIButton *btn = [UIButton buttonWithType:UIButtonTypeRoundedRect];
		btn.frame = CGRectMake(100, 100, CLASSROOM_BOARD_WIDTH, CLASSROOM_BOARD_HEIGHT);
		btn.bounds = CGRectMake(0, 0, CLASSROOM_BOARD_WIDTH, CLASSROOM_BOARD_HEIGHT);
		[btn setBackgroundImage:[UIImage imageNamed:@"FullBoard_Icon.png"] forState:UIControlStateNormal];
		[btn addTarget:self action:@selector(touchDownBoardButton:forEvent:) forControlEvents:UIControlEventTouchDown];
		[btn addTarget:self action:@selector(touchMoveBoardButton:forEvent:) forControlEvents:UIControlEventTouchDragInside];
		[btn addTarget:self action:@selector(touchUpBoardButton:forEvent:) forControlEvents:UIControlEventTouchUpInside];
		[buttonsView addSubview:btn];
		[boardButtons addObject:btn];
		
		// Make this board selected
		[self selectBoardButton:btn];
	}
	if (sender == removeButton)
	{
		// Adjust board #s
		int boardNum = [boardButtons indexOfObject:selectedButton];
		for (id obj in lecture.boardList)
		{
			Board *board = obj;
			if (board.physicalBoardNumber == boardNum)
				board.physicalBoardNumber = -1;
			if (board.physicalBoardNumber > boardNum)
				board.physicalBoardNumber--;
		}
		
		// Delete board
		UIButton *tmp = selectedButton;
		[self deselectBoardButton];
		[tmp removeFromSuperview];
		[boardButtons removeObject:tmp];
	}
	if (sender == saveButton)
	{
		//Bring up save box
		if (save_alert == nil){
				save_alert = [[UIAlertView alloc] initWithTitle:@"Save Arrangement" message:@"\n"
														   delegate:self cancelButtonTitle:@"Cancel"
												  otherButtonTitles: nil];
		}
			
			[save_alert setTransform:CGAffineTransformMakeTranslation(0.0, 85)];
		
		if (save_textfield == nil){
				save_textfield = [[UITextField alloc] initWithFrame:CGRectMake(12.0, 45.0, 260.0, 25.0)];
		}
			
			[save_textfield setBackgroundColor:[UIColor whiteColor]];
			[save_alert addSubview:save_textfield];
			
			
			
			save_textfield.delegate = self;
			save_textfield.keyboardType = UIKeyboardTypeAlphabet;
			save_textfield.keyboardAppearance = UIKeyboardAppearanceAlert;
			save_textfield.autocorrectionType = UITextAutocorrectionTypeNo;
			save_textfield.returnKeyType = UIReturnKeyDone;
			[save_textfield becomeFirstResponder];
			
			[save_alert show];
	}
	
	if (sender == loadButton){
//		ClassroomConfigLoadViewController *cclVC = [[ClassroomConfigLoadViewController alloc] initWithNibName:@"ClassroomConfigLoadViewController" bundle:nil];
//		cclVC.delegate = self;
//		[self presentModalViewController:cclVC animated:YES];
//		[cclVC release];
	}
}

-(BOOL)textFieldShouldReturn:(UITextField *)textField
{
	[textField resignFirstResponder];
	
	if (textField == save_textfield)
	{
		//save this arrangement to disk
		NSString *saveName = save_textfield.text;
		
		[save_alert dismissWithClickedButtonIndex:0 animated:YES];
	}
	return YES;
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
	if (alertView == save_alert) {
		// Do nothing
	}
}


-(void)touchDownBoardButton:(id)sender forEvent:(UIEvent*)event
{
	UIButton *bb = sender;
	prevLoc = [(UITouch*)[[event touchesForView:bb] anyObject] locationInView:buttonsView];
	
	// Toggle selection
	if (selectedButton == bb)
		[self deselectBoardButton];
	else
		[self selectBoardButton:bb];
}

-(void)touchMoveBoardButton:(id)sender forEvent:(UIEvent*)event
{
	UIButton *bb = sender;
	CGPoint currLoc = [(UITouch*)[[event touchesForView:bb] anyObject] locationInView:buttonsView];
	float dx = currLoc.x - prevLoc.x;
	float dy = currLoc.y - prevLoc.y;
	
	// Keep this board selected
	[self selectBoardButton:bb];
	
	// Make sure the button doesn't go outside the bounds of the view
	if (bb.frame.origin.x+dx > CGRectGetMinX(buttonsView.bounds) &&
		bb.frame.origin.x+bb.frame.size.width+dx < CGRectGetMaxX(buttonsView.bounds) &&
		bb.frame.origin.y+dy > CGRectGetMinY(buttonsView.bounds) &&
		bb.frame.origin.y+bb.frame.size.height+dy < CGRectGetMaxY(buttonsView.bounds))
	{
		bb.frame = CGRectMake(bb.frame.origin.x+dx, bb.frame.origin.y+dy, bb.frame.size.width, bb.frame.size.height);
	}
	prevLoc = currLoc;
}

-(void)touchUpBoardButton:(id)sender forEvent:(UIEvent*)event
{
	//UIButton *bb = sender;
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
	if (interfaceOrientation == UIInterfaceOrientationLandscapeLeft || interfaceOrientation == UIInterfaceOrientationLandscapeRight){
		return YES;
	}else
	{
		//Doing it this way because we may want some screens to support portrait later, like the lecture chooser.
		return NO;
	}
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[doneButton release];
	[addButton release];
	[removeButton release];
	[lecture release];
	[boardButtons release];
	[buttonsView release];
	[save_alert release];
    [super dealloc];
}


@end
