//
//  HelpViewController.m
//  WBA
//
//  Created by Class Account on 4/2/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "HelpViewController.h"
#import "LectureOverviewViewController.h"
#import "BoardViewController.h"
#import "PresentationViewController.h"

@implementation HelpViewController

@synthesize imView;
@synthesize dismissButton;
@synthesize prevButton;
@synthesize nextButton;
@synthesize parentController;

+(void)initialize
{
	// Set up the static array of images here
	overviewHelpImages = [[NSArray alloc] initWithObjects:@"lohelp1.png", @"lohelp2.png", @"lohelp3.png", nil];
	boardviewHelpImages = [[NSArray alloc] initWithObjects:@"behelp1.png", @"behelp2.png", @"behelp3.png", @"behelp4.png", nil];
	presentationHelpImages = [[NSArray alloc] initWithObjects:@"preshelp1.png", @"preshelp2.png", @"preshelp3.png", @"preshelp4.png", nil];
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

-(void)viewWillAppear:(BOOL)animated
{
	[super viewWillAppear:animated];
	
	currPos = 0;
	if ([parentController class] == [LectureOverviewViewController class])
		myImages = [overviewHelpImages retain];
	if ([parentController class] == [BoardViewController class])
		myImages = [boardviewHelpImages retain];
	if ([parentController class] == [PresentationViewController class])
		myImages = [presentationHelpImages retain];
	imView.image = [UIImage imageNamed:[myImages objectAtIndex:currPos]];
	imView.contentMode = UIViewContentModeScaleAspectFit;
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
	if (interfaceOrientation == UIInterfaceOrientationLandscapeLeft || interfaceOrientation == UIInterfaceOrientationLandscapeRight){
		return YES;
	}else
	{
		//Doing it this way because we may want some screens to support portrait later, like the lecture chooser.
		return NO;
	}
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

-(IBAction)toolbarButtonPressed:(id)sender
{
	if (sender == dismissButton)
	{
		[self dismissModalViewControllerAnimated:YES];
	}
	if (sender == prevButton)
	{
		nextButton.enabled = YES;
		if (currPos > 0)
		{
			currPos--;
			imView.image = [UIImage imageNamed:[myImages objectAtIndex:currPos]];
			if (currPos == 0)
				prevButton.enabled = NO;
			[imView setNeedsDisplay];
		}
	}
	if (sender == nextButton)
	{
		prevButton.enabled = YES;
		if (currPos < myImages.count-1)
		{
			currPos++;
			imView.image = [UIImage imageNamed:[myImages objectAtIndex:currPos]];
			if (currPos == myImages.count-1)
				nextButton.enabled = NO;
			[imView setNeedsDisplay];
		}
	}
}

- (void)dealloc {
	[imView release];
	[dismissButton release];
	[prevButton release];
	[nextButton release];
	[parentController release];
	[myImages release];
    [super dealloc];
}


@end
