//
//  IconBoardView.h
//  WBA
//
//  Created by Class Account on 4/2/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

/*
 * IconBoardView is the class used for displaying boards in the Lecture Overview
 */

#import <UIKit/UIKit.h>
#import "BoardView.h"


@interface IconBoardView : BoardView {
	bool isBeingDragged;
	UIViewController *delegate;
	int originDragIndex;
	int dragIndex;
	int boardIndex;
	NSTimer *touchTimer;
	UIImageView *deleteMark; 
}

@property (readwrite, assign) bool isBeingDragged;
@property (nonatomic, retain) UIViewController *delegate;
@property (readonly) int originDragIndex;
@property (readonly) int dragIndex;
@property (readwrite, assign) int boardIndex;
@property (nonatomic, retain) UIImageView* deleteMark;

-(void)drawFlagForWholeBoard;

-(void)animateStartDrag;
-(void)animateEndDrag;
-(void)startDrag;
-(void)setupDrag:(NSTimer *)timer;

-(int) getBoardPosition:(CGPoint)p;
-(void)selectBoard;
-(void)invalidateTimer;

@end
