//
//  LectureDurationPicker.m
//  WBA
//
//  Created by efung on 4/28/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "LectureDurationPicker.h"


@implementation LectureDurationPicker

@synthesize durationPicker, doneButton, lsvc, lecture;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


-(void)viewWillAppear:(BOOL)animated
{
	[super viewWillAppear:animated];
//    [[UIApplication sharedApplication] setStatusBarOrientation: UIInterfaceOrientationPortrait  animated: YES];
}


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	// Creat the date picker
	UIInterfaceOrientation curOrientation = self.interfaceOrientation;
	[[UIApplication sharedApplication] setStatusBarOrientation: UIInterfaceOrientationPortrait  animated: NO];
	durationPicker = [[UIDatePicker alloc] initWithFrame: CGRectZero];
	[[UIApplication sharedApplication] setStatusBarOrientation: curOrientation animated: NO];
	durationPicker.frame = CGRectMake(0, 44, 480, 232);
	durationPicker.datePickerMode = UIDatePickerModeCountDownTimer;
	[self.view addSubview:durationPicker];
	[durationPicker addTarget:self action:@selector(updateLectureDuration:) forControlEvents:UIControlEventValueChanged];

	// Hackish way to get 0hrs 50 minutes to display: using a date with time midnight (PST) and manually adding offset.
	int time = lsvc.model.duration;
	time *= 60;  // convert minutes to seconds
	time += -57600;  // subtract 16 hours to offset default 1970 date from midnight
	[durationPicker setDate:[NSDate dateWithTimeIntervalSince1970:(NSTimeInterval)time] animated:YES];

	// Only real workaround, though it takes out the hour and minute labels
//	for (UIPickerView * subview in durationPicker.subviews) {
//        subview.frame = durationPicker.bounds;
//    }
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
	if (interfaceOrientation == UIInterfaceOrientationLandscapeLeft || interfaceOrientation == UIInterfaceOrientationLandscapeRight){
		return YES;
	}else
	{
		//Doing it this way because we may want some screens to support portrait later, like the lecture chooser.
		return NO;
	}
}

-(IBAction)donePressed:(id)sender {
	[lsvc updateDuration];
	[self dismissModalViewControllerAnimated:YES];
}

// Update lecture's duration for each change in the date picker
- (IBAction)updateLectureDuration:(id)sender {
	NSTimeInterval timeInSeconds = durationPicker.countDownDuration;

	// Store duration in minutes instead of seconds
	lecture.duration = (int) timeInSeconds / 60;
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[doneButton release];
	[durationPicker release];
	[lecture release];
    [super dealloc];
}


@end
