//
//  LectureOverviewOverlay.m
//  WBA
//
//  Created by Class Account on 4/2/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "LectureOverviewOverlay.h"
#import "LectureOverviewViewController.h"


@implementation LectureOverviewOverlay

@synthesize delegate;

//Forwards the touchesBegan event to the appropriate IconBoardView (only!)
-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
	LectureOverviewViewController *del = (LectureOverviewViewController *)delegate;

	for (IconBoardView *btn in del.boardsArea.subviews){
		if (CGRectContainsPoint([btn frame], [[touches anyObject] locationInView:del.boardsArea])) {
			[btn touchesBegan:touches withEvent:event];
		}
	}
}	

//Forwards a touch moved event to the appropriate IconBoardView (only!)
-(void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{  
	LectureOverviewViewController *del = (LectureOverviewViewController *)delegate;

	for (IconBoardView *btn in del.boardsArea.subviews){
		if ([btn class] == [IconBoardView class] && btn.isBeingDragged){//if (CGRectContainsPoint([btn frame], [[touches anyObject] locationInView:delegate])) {
			[btn touchesMoved:touches withEvent:event];
		}
	}
}

//Forwards a touch ended event to the appropriate IconBoardView (only!). Hides the overlay
-(void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
	LectureOverviewViewController *del = (LectureOverviewViewController *)delegate;

	self.hidden = YES;
	for (IconBoardView *btn in del.boardsArea.subviews){
		if ([btn class] == [IconBoardView class] && (btn.isBeingDragged || CGRectContainsPoint([btn frame], [[touches anyObject] locationInView:del.boardsArea]))) {
			[btn touchesEnded:touches withEvent:event];
		}
	}
}


- (void)dealloc {
    [super dealloc];
	[delegate release];
}


@end
