//
//  LectureOverviewViewController.h
//  WBA
//
//  Created by Class Account on 3/18/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//



#import <UIKit/UIKit.h>
#import "Lecture.h"
#import "IconBoardView.h"
#import "BoardViewController.h"



@interface LectureOverviewViewController : UIViewController {
	
	// UI Elements
	UIScrollView *scrollLectureView;
	
	UIBarButtonItem *startPresentationButton;
	UIBarButtonItem *settingsButton;
	
	UIToolbar *bottomBar;
	
	BOOL editMode;
	
	// Model
	Lecture *model;
	
	UIView *deleteArea;
}

@property (nonatomic, retain) IBOutlet UIScrollView *scrollLectureView;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *startPresentationButton;
@property (nonatomic, retain) IBOutlet UIToolbar *bottomBar;
@property (nonatomic, readonly) UIView *deleteArea;
@property (readonly) BOOL editMode;

@property (nonatomic, retain) Lecture *model;

-(void)settingsAccepted;

-(void) updateBoards;
-(IBAction) addBoard;
-(IBAction) showHelp;
-(void) showSettings;
-(IBAction) startPresentation;

-(void)simulateEditorDonePlusBoardSelected:(BoardViewController*)bVC;

-(IconBoardView *)getIconBoardViewForBoard:(Board *) b;
-(void) refreshBoards;
-(void)arrangeBoard:(IconBoardView*)board atIndex:(int)index;
-(void)startEditing;
-(void)doneEditing;
-(void)boardSelected:(Board *)board atPosition:(int)pos;
-(void) setScrollContentSize;

@end
