//
//  PhysBoardLocViewController.m
//  WBA
//
//  Created by Class Account on 4/27/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "PhysBoardLocViewController.h"


@implementation PhysBoardLocViewController

@synthesize myNavBar, lecture, board, isEditing, buttonsView, doneButton;


 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
		boardButtons = [[NSMutableArray alloc] init];
    }
    return self;
}

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

-(void)viewWillAppear:(BOOL)animated
{
	[super viewWillAppear:animated];
	
	if (isEditing)
		myNavBar.topItem.title = @"On which board should this go?";
	else
		myNavBar.topItem.title = @"Draw this board here:";
	
	// Set up boards according to lecture data structure
	for (int i = 0; i < lecture.physBoardPos.count; i++)
	{
		// Add a button, then change it's location appropriately
		UIButton *btn = [UIButton buttonWithType:UIButtonTypeRoundedRect];
		btn.frame = CGRectMake(100, 100, CLASSROOM_BOARD_WIDTH, CLASSROOM_BOARD_HEIGHT);
		btn.bounds = CGRectMake(0, 0, CLASSROOM_BOARD_WIDTH, CLASSROOM_BOARD_HEIGHT);
		[btn setBackgroundImage:[UIImage imageNamed:@"FullBoard_Icon.png"] forState:UIControlStateNormal];
		if (isEditing)
			[btn addTarget:self action:@selector(touchDownBoardButton:forEvent:) forControlEvents:UIControlEventTouchDown];
		[buttonsView addSubview:btn];
		[boardButtons addObject:btn];
		btn.titleLabel.font = [btn.titleLabel.font fontWithSize:22];
		
		CGPoint origin = [(NSValue*)[lecture.physBoardPos objectAtIndex:i] CGPointValue];
		btn.frame = CGRectMake(origin.x, origin.y, btn.frame.size.width, btn.frame.size.height);
		
		if (board && i == board.physicalBoardNumber)
			[self setSelectedBoard:i];
	}
}

-(void)touchDownBoardButton:(id)sender forEvent:(UIEvent*)event
{
	UIButton *bb = sender;
	[self setSelectedBoard:[boardButtons indexOfObject:bb]];
	[self dismissModalViewControllerAnimated:YES];
}

-(void)setSelectedBoard:(int)physBoardNum
{
	for (id obj in boardButtons)
	{
		UIButton *bb = obj;
		[bb setBackgroundImage:[UIImage imageNamed:@"FullBoard_Icon.png"] forState:UIControlStateNormal];
	}
	UIButton *bb = [boardButtons objectAtIndex:physBoardNum];
	[bb setBackgroundImage:[UIImage imageNamed:@"FullBoard_Highlighted.png"] forState:UIControlStateNormal];
	board.physicalBoardNumber = physBoardNum;
}

-(IBAction)dismiss
{
	[self dismissModalViewControllerAnimated:YES];
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
	if (interfaceOrientation == UIInterfaceOrientationLandscapeLeft || interfaceOrientation == UIInterfaceOrientationLandscapeRight){
		return YES;
	}else
	{
		//Doing it this way because we may want some screens to support portrait later, like the lecture chooser.
		return NO;
	}
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[myNavBar release];
	[board release];
	[lecture release];
	[buttonsView release];
	[boardButtons release];
	[doneButton release];
    [super dealloc];
}


@end
