//
//  PresentationBoardView.m
//  WBA
//
//  Created by Class Account on 4/2/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "PresentationBoardView.h"


@implementation PresentationBoardView


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        // Initialization code
		drawRegion = CGRectMake(PRESMODE_BOARD_X, PRESMODE_BOARD_Y, PRESMODE_BOARD_WIDTH, PRESMODE_BOARD_HEIGHT);
		separatorWidth = PRESMODE_LINEWIDTH;
		flagSize = PRESMODE_BOARD_FLAG_SIZE;
		thumbSize = PRESMODE_BOARD_PHOTO_THUMB_SIZE;
    }
    return self;
}

- (id)initWIthCoder:(NSCoder*)coder {
    if (self = [super initWithCoder:coder]) {
        // Initialization code
		drawRegion = CGRectMake(PRESMODE_BOARD_X, PRESMODE_BOARD_Y, PRESMODE_BOARD_WIDTH, PRESMODE_BOARD_HEIGHT);
		separatorWidth = PRESMODE_LINEWIDTH;
		flagSize = PRESMODE_BOARD_FLAG_SIZE;
		thumbSize = PRESMODE_BOARD_PHOTO_THUMB_SIZE;
    }
    return self;
}

-(void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
  
  
	if ([self pointOnFlagButton:[[touches anyObject] locationInView:self]]) {
		BoardSection *sec = [self sectionContainingPoint:[[touches anyObject] locationInView:self]];
		if (sec)
		{
		  
		  NSLog(@"Recording sound\n");
 		  AudioNote *an = [AudioNote alloc];
 		  [an setModel:sec];
 		  [an record];
 		  [sec setFlag:an.soundPath];

		}
		[self setNeedsDisplay];
	}

	if ([self pointOnPhotoButton:[[touches anyObject] locationInView:self]]) {
		BoardSection *sec = [self sectionContainingPoint:[[touches anyObject] locationInView:self]];
		if (sec)
		{
			UIImage *img = [sec getPhotoAnnotation];
			NSLog(@"pressed the photo button");
			[controller launchPhotoViewer:img];
			
			[self setNeedsDisplay];
		}
	}

	
	
}


- (void)drawRect:(CGRect)rect {
    // Drawing code
	[super drawRect:rect];
	
	// Draw section text, photo icons
	for (id obj in model.sections)
	{
		[self drawSectionText:obj labelsOnly:YES];
		[self drawSectionPhotoIcon:obj];
		[self drawSectionFlagIcon:obj flagCode:2];
	}
}


- (void)dealloc {
    [super dealloc];
}


@end
