//
//  PresentationImageViewController.m
//  WBA
//
//  Created by Class Account on 4/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "PresentationImageViewController.h"
@interface PresentationImageViewController()
//private
-(void)setupImage;

@end

@implementation PresentationImageViewController

@synthesize scrollImage, myToolbar;


 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
      timerNotice = nil;
      presImage = [[UIImageView alloc] init];
      myLabel = [UILabel alloc];
      myLabel.text = @"Image Viewer";
    }
    return self;
}


-(IBAction)dismissView{
	[self dismissModalViewControllerAnimated:NO];
}

-(void)setTimer:(TimerNoticeView*)tnv
{
	timerNotice = [tnv retain];
}

-(void)setImage:(UIImage*)image{
	presImage =[[UIImageView alloc] initWithImage:image];
	presImage.frame = CGRectMake(0, 0, image.size.width, image.size.height);
	[self setupImage];
}

-(void)setupImage
{
	presImage.contentMode = UIViewContentModeScaleAspectFit;
	CGSize imageDim = [presImage.image size];
	if (imageDim.width > imageDim.height) {
		CGAffineTransform rotate = CGAffineTransformMakeRotation(3.0 * M_PI / 2.0 );
		[presImage setTransform:rotate];
	}
	[scrollImage addSubview:presImage];
	presImage.frame = CGRectMake(0, 0, scrollImage.frame.size.width*1.05, scrollImage.frame.size.height*1.05);
	[scrollImage setContentSize:CGSizeMake(presImage.frame.size.width, presImage.frame.size.height)];
	[scrollImage setMinimumZoomScale:1.0];
	[scrollImage setMaximumZoomScale:4.0];
	
}

- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView{
	return presImage;
}

-(void)viewWillAppear:(BOOL)animated
{
	[super viewWillAppear:animated];
	
	NSMutableArray *tmp = [NSMutableArray arrayWithArray:myToolbar.items];
	if (timerNotice != nil) {
	  [tmp insertObject:[[UIBarButtonItem alloc] initWithCustomView:timerNotice] atIndex:1];;
	}
	[myToolbar setItems:tmp animated:NO];
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	[self setupImage];
}




// Image view is always in portrait mode, but the image itself may be
// roatated to make better use of the phone's aspect ratio
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[presImage release];
	[scrollImage release];
	[myToolbar release];
	if (timerNotice)
		[timerNotice release];
	[super dealloc];
}


@end
