//
//  TimeSetViewController.m
//  WBA
//
//  Created by Class Account on 4/9/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "TimeSetViewController.h"

#define SLIDER_BUTTON_WIDTH 20


@implementation TimeSetViewController

@synthesize board, lecture, accept, boardMinsLabel, lecEndLabel, mySlider, posInLecture;
@synthesize overlay, overlay2, totalMinsLabel;

-(IBAction)buttonClicked:(id)sender
{
	if (sender == accept)
	{
		// set model
		board.minutes = mins;
		
		[self dismissModalViewControllerAnimated:YES];
	}
}

-(void)initTickMarks
{
	float minsSoFar = 0;
	for (int i = 0; i < [lecture numBoards]; i++)
	{
		minsSoFar += [lecture getBoard:i].minutes;
		float ratio = ((float)minsSoFar)/lecture.duration;
		float width = ratio*(mySlider.frame.size.width - SLIDER_BUTTON_WIDTH);
		float x = mySlider.frame.origin.x+SLIDER_BUTTON_WIDTH/2.0+width;
		float y = mySlider.frame.origin.y+mySlider.frame.size.height;
		CGRect frame = CGRectMake(x, y, 5, 10);
		UILabel* tick = [[UILabel alloc] initWithFrame:frame];
		tick.text = @"l";
		tick.font = [tick.font fontWithSize:13];
		tick.backgroundColor = [tick.backgroundColor colorWithAlphaComponent:0];
		[self.view addSubview:tick];
		[ticks addObject:tick];
	}
}

-(void)updateTickMarks
{
	float minsSoFar = 0;
	for (int i = 0; i < [lecture numBoards]; i++)
	{
		if (i == posInLecture)
			minsSoFar = mySlider.value;
		else
			minsSoFar += [lecture getBoard:i].minutes;
		float ratio = ((float)minsSoFar)/lecture.duration;
		float width = ratio*(mySlider.frame.size.width - SLIDER_BUTTON_WIDTH);
		float x = mySlider.frame.origin.x+SLIDER_BUTTON_WIDTH/2.0+width;
		float y = mySlider.frame.origin.y+mySlider.frame.size.height;
		CGRect frame = CGRectMake(x, y, 5, 10);
		UILabel *tick = [ticks objectAtIndex:i];
		tick.frame = frame;
		[tick setNeedsDisplay];
	}
}

-(void)updateOverlays
{
	float overlayY = mySlider.frame.origin.y+4;
	float overlayHeight = mySlider.frame.size.height-7;
	
	float beforeRatio = ((float)minsBefore)/lecture.duration;
	float beforeWidth = beforeRatio*(mySlider.frame.size.width - SLIDER_BUTTON_WIDTH);
	float beforeOrigin = mySlider.frame.origin.x + SLIDER_BUTTON_WIDTH/2.0;
	overlay.frame = CGRectMake(beforeOrigin, overlayY, beforeWidth, overlayHeight);
	
	float afterRatio = ((float)minsAfter)/lecture.duration;
	float notAfterRatio = ((float)mySlider.value)/lecture.duration;
	float afterWidth = afterRatio*(mySlider.frame.size.width - SLIDER_BUTTON_WIDTH);
	float afterOrigin = beforeOrigin + notAfterRatio*(mySlider.frame.size.width - SLIDER_BUTTON_WIDTH);
	overlay2.frame = CGRectMake(afterOrigin, overlayY, afterWidth, overlayHeight);
	
	float labelStart = mySlider.frame.origin.x + SLIDER_BUTTON_WIDTH/2.0 - totalMinsLabel.frame.size.width/3.0;
	float labelOffset = notAfterRatio*(mySlider.frame.size.width - SLIDER_BUTTON_WIDTH);
	float labelOrigin = labelStart + labelOffset;
	totalMinsLabel.frame = CGRectMake(labelOrigin, totalMinsLabel.frame.origin.y, totalMinsLabel.frame.size.width, totalMinsLabel.frame.size.height);
}

-(IBAction)scrollBarScrolled:(id)sender
{
	if (mySlider.value < minsBefore)
	{
		mySlider.value = minsBefore;
	}
	if (mySlider.value + minsAfter > lecture.duration)
	{
		mySlider.value = lecture.duration - minsAfter;
	}
	mins = (mySlider.value - minsBefore);
	
	totalMinsLabel.text = [NSString stringWithFormat:@"%d", (int)mySlider.value];
	boardMinsLabel.text = [NSString stringWithFormat:@"%d", mins];
	
	totalMinsLabel.hidden = NO;
	[self updateOverlays];
	
	[self.view bringSubviewToFront:mySlider];
	
	[self updateTickMarks];
}

-(IBAction)scrollBarDone:(id)sender{
	mySlider.value = (int)mySlider.value;
	totalMinsLabel.hidden = YES;
}

 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
		ticks = [[NSMutableArray alloc] init];
    }
    return self;
}

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

-(void)viewWillAppear:(BOOL)animated
{
	[super viewWillAppear:animated];
	
	lecEndLabel.text = [NSString stringWithFormat:@"%d", lecture.duration];
	
	mins = board.minutes;
	
	// Figure out how many minutes come before this board.
	minsBefore = 0;
	if ([lecture numBoards] > 0)
	{
		for (int i = 0; i < posInLecture; i++)
		{
			minsBefore += [lecture getBoard:i].minutes;
		}
	}
	// Figure out how many minutes come after this board.
	minsAfter = 0;
	if ([lecture numBoards] > 0)
	{
		for (int i = posInLecture+1; i < [lecture numBoards]; i++)
		{
			minsAfter += [lecture getBoard:i].minutes;
		}
	}
	
	// Set slider params accordingly
	mySlider.minimumValue = 0;
	mySlider.maximumValue = lecture.duration;
	[mySlider setValue:(minsBefore+mins) animated:NO];
	boardMinsLabel.text = [NSString stringWithFormat:@"%d", mins];
	
	// Set up overlays
	[self updateOverlays];
	
	// Set labels
	lecEndLabel.text = [NSString stringWithFormat:@"%d", lecture.duration];
	
	[self.view bringSubviewToFront:mySlider];
	
	[self initTickMarks];
}


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}


// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
	if (interfaceOrientation == UIInterfaceOrientationLandscapeLeft || interfaceOrientation == UIInterfaceOrientationLandscapeRight){
		return YES;
	}else
	{
		//Doing it this way because we may want some screens to support portrait later, like the lecture chooser.
		return NO;
	}
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[lecture release];
	[board release];
	[accept release];
	[mySlider release];
	[boardMinsLabel release];
	[lecEndLabel release];
	[overlay release];
	[overlay2 release];
	[totalMinsLabel release];
	[ticks release];
    [super dealloc];
}


@end
