//
//  TimerNoticeView.m
//  WBA
//
//  Created by Class Account on 4/6/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "TimerNoticeView.h"


@implementation TimerNoticeView


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        // Initialization code
		textlabel = [[UILabel alloc] initWithFrame:frame];
		textlabel.textAlignment = UITextAlignmentCenter;
		textlabel.textColor = [UIColor colorWithRed:1 green:1 blue:1 alpha:1];
		textlabel.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0];
		textlabel.font = [textlabel.font fontWithSize:14];
		[self addSubview:textlabel];
		
		state = BOARDTIME;
		
		self.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0];
    }
    return self;
}

- (void)drawRect:(CGRect)rect
{
    // Drawing code
	switch (state)
	{
		case BOARDTIME:
			[self drawBoardTimer:rect];
			break;
		case LECTUREUP:
			[self drawLecCountUp:rect];
			break;
		case LECTUREDOWN:
			[self drawLecCountDown:rect];
			break;
		default:
			break;
	}
	
	// Finally, need to actually fill the rounded rectangle
	/*
	 Code based on example from: http://iphonedevelopment.blogspot.com/2008/11/creating-transparent-uiviews-rounded.html
	 */
	CGContextRef contextRef = UIGraphicsGetCurrentContext();
	CGContextSetLineWidth(contextRef, 3);
	CGContextSetStrokeColorWithColor(contextRef, [UIColor whiteColor].CGColor);
	float radius = 7;
	float minx = CGRectGetMinX(rect);
    float midx = CGRectGetMidX(rect);
    float maxx = CGRectGetMaxX(rect);
    float miny = CGRectGetMinY(rect);
    float midy = CGRectGetMidY(rect);
    float maxy = CGRectGetMaxY(rect);
	CGContextMoveToPoint(contextRef, minx, midy);
    CGContextAddArcToPoint(contextRef, minx, miny, midx, miny, radius);
    CGContextAddArcToPoint(contextRef, maxx, miny, maxx, midy, radius);
    CGContextAddArcToPoint(contextRef, maxx, maxy, midx, maxy, radius);
    CGContextAddArcToPoint(contextRef, minx, maxy, minx, midy, radius);
    CGContextClosePath(contextRef);
    CGContextDrawPath(contextRef, kCGPathFillStroke);
}

-(void)drawBoardTimer:(CGRect)rect
{
	CGContextRef contextRef = UIGraphicsGetCurrentContext();
	
	// Set color based on time left
	if (timeLeftForBoard <= BLACK)
	{
		CGContextSetRGBFillColor(contextRef, 0, 0, 0, 1);
	}
	else if (timeLeftForBoard <= RED)
	{
		CGContextSetRGBFillColor(contextRef, 91/255.0, 42/255.0, 43/255.0, 1);
	}
	else if (timeLeftForBoard < YELLOW)
	{
		CGContextSetRGBFillColor(contextRef, 128/255.0, 118/255.0, 61/255.0, 1);
	}
	else
	{
		CGContextSetRGBFillColor(contextRef, 61/255.0, 114/255.0, 65/255.0, 1);
	}
	
	// Set text
	if (timeLeftForBoard <= BLACK)
	{
		textlabel.text = @"No time left on this board";
	}
	else
	{
		textlabel.text = [NSString stringWithFormat:@"%d mins left on this board", timeLeftForBoard/60];
	}
}

-(void)drawLecCountDown:(CGRect)rect
{
	CGContextRef contextRef = UIGraphicsGetCurrentContext();
	CGContextSetRGBFillColor(contextRef, 44/255.0, 60/255.0, 93/255.0, 1);
	int time = (lecDuration - timeElapsed/60);
	if (time == 1)
		textlabel.text = [NSString stringWithFormat:@"%d total min left", time];
	textlabel.text = [NSString stringWithFormat:@"%d total mins left", time];
}

-(void)drawLecCountUp:(CGRect)rect
{
	CGContextRef contextRef = UIGraphicsGetCurrentContext();
	CGContextSetRGBFillColor(contextRef, 44/255.0, 60/255.0, 93/255.0, 1);
	int time = timeElapsed/60;
	if (time == 1)
		textlabel.text = [NSString stringWithFormat:@"%d total min used", timeElapsed/60];
	textlabel.text = [NSString stringWithFormat:@"%d total mins used", timeElapsed/60];
}

-(void)update:(int)duration elapsed:(int)elapsed forBoard:(int)forBoard;
{
	lecDuration = duration;
	timeElapsed = elapsed;
	timeLeftForBoard = forBoard;
	[self setNeedsDisplay];
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
	state = (state + 1) % NUMSTATES;
	[self setNeedsDisplay];
}

- (void)dealloc {
	[textlabel release];
    [super dealloc];
}


@end
