/*
 *  globals.h
 *  WBA
 *
 *  Created by Class Account on 3/29/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef _GLOBALS_H
#define _GLOBALS_H

#import <Foundation/Foundation.h>

#define DEBUG 1

#pragma mark constants

#define EMPTY_LECTURE_TITLE @""
#define DEFAULT_LECTURE_TITLE @"Unnamed Lecture"

#define PHOTO_THUMB_PADDING 3
#define PHOTO_THUMB_STROKE_WIDTH 3

#define EDMODE_BOARD_WIDTH 360
#define EDMODE_BOARD_HEIGHT 255
#define EDMODE_BOARD_X 10
#define EDMODE_BOARD_Y 10

#define EDMODE_BOARD_FLAG_SIZE 40
#define EDMODE_BOARD_PHOTO_THUMB_SIZE 60

#define PRESMODE_BOARD_WIDTH 375
#define PRESMODE_BOARD_HEIGHT 265
#define PRESMODE_BOARD_X 0
#define PRESMODE_BOARD_Y 0

#define PRESMODE_PADDING 105

#define PRESMODE_BOARD_FLAG_SIZE 40
#define PRESMODE_BOARD_PHOTO_THUMB_SIZE 80

#define BUTTON_DIM_X 40
#define BUTTON_DIM_Y 40


#define ICONMODE_BOARD_WIDTH 225
#define ICONMODE_BOARD_HEIGHT 160
#define ICONMODE_BOARD_SPACING 30
#define ICONMODE_BOARD_X 0
#define ICONMODE_BOARD_Y 35

#define ICONMODE_EDIT_BOARD_WIDTH 75
#define ICONMODE_EDIT_BOARD_HEIGHT 53
#define ICONMODE_EDIT_BOARD_SPACING 10



// Should be even numbers (for symmetry)
#define EDMODE_LINEWIDTH 2
#define PRESMODE_LINEWIDTH 2
#define ICONMODE_LINEWIDTH 2

#define LAYOUT_ICON_WIDTH 130
#define LAYOUT_ICON_HEIGHT 92
#define LAYOUT_ICON_HSPACE 34
#define LAYOUT_ICON_VSPACE 34

#define CLASSROOM_BOARD_WIDTH 130
#define CLASSROOM_BOARD_HEIGHT 92


#pragma mark enums

// Types of board elements
typedef enum {
	Empty,
	Proof,
	Definition,
	Theorem,
	Graph,
	Diagram,
	UOList,
	OList,
	Example,
	QandA,
	Custom
	// etc.
} ElementType;

// Types of board layouts
typedef enum {
	FullBoard,
	Horiz2Split,
	Vert2Split,
	Vert2and1Split,
	Vert1and2Split,
	Vert3Split,
	Horiz3Split,
	Horiz2and1Split,
	Horiz1and2Split,
	FourWaySplit
	// etc.
} LayoutType;


#pragma mark vectorMath

inline CGPoint vadd(CGPoint v1, CGPoint v2)
{
	CGPoint vr;
	vr.x = v1.x + v2.x;
	vr.y = v2.x + v2.y;
	return vr;
}


#endif


#pragma mark serialization

// Board section keys
#define BSECT_REGION_KEY          @"region"
#define BSECT_ELEEMENT_KEY        @"element"
#define BSECT_TEXT_ANNOTATION_KEY @"textAnnotation"
#define BSECT_SOUND_FILE_KEY      @"soundFile"
#define BSECT_PHOTO_FILE_KEY      @"photoFile"
#define BSECT_REGION_X            @"x"
#define BSECT_REGION_Y            @"y"
#define BSECT_REGION_W            @"w"
#define BSECT_REGION_H            @"h"


// Board keys
#define BOARD_SECTIONS_KEY        @"sections"
#define BOARD_MINS_KEY            @"minutes"
#define BOARD_PHYSICAL_KEY        @"physicalBoardNumber"
#define BOARD_LAYOUT_KEY          @"layout"

//Lecture keys
#define LEC_ID_KEY                @"lid"
#define LEC_BOARDS_KEY            @"boards"
#define LEC_BOARDS_POS_KEY        @"physBoardPos"
#define LEC_TIMING_KEY            @"timing"
#define LEC_TITLE_KEY             @"title"
#define LEC_DURATION_KEY          @"duration"
#define LEC_PHYSBOARDPOS_X        @"x"
#define LEC_PHYSBOARDPOS_Y        @"y"
